;Copyright 2004 by Samuel Stearley


	include	"os.h"

	xdef		_nostub
	xdef		_ti89



;---Clear screen, and print message----

	movem.l	d3-d7/a2-a6,-(a7)
	move		#$0200,d0
	trap		#1
	move.w	d0,-(a7)


	move.l	200,a6		;jump table
	lea		LCD_MEM,a0
	move.w	#959,d0
Backup:
	move.l	(a0)+,-(a7)
	dbra		d0,Backup
	move.l	#3000,d0
	sub.l		d0,a7

	moveq		#0,d7

DoItAllOver:
	lea		LCD_MEM,a0
	move.w	#959,d0
ClearIt:
	clr.l		(a0)+
	dbra		d0,ClearIt

	move.w	#4,-(a7)
	pea		msg(pc)
	pea		92
	move.l	1700(a6),a0
	jsr		(a0)
	lea		10(a7),a7

;---initiation-----

DoItRepeatedly:
	move.l	1060(a6),a0		;top estack
	move.l	(a0),a3		;the arg
	cmp.b		#$1f,(a3)
	bne		NotAnInt
	lea		900(a7),a2		;place to keep the string
	lea		1400(a7),a1		;place to put the BCD
	lea		1401(a7),a4		;place to put the lookup table

;---Generate the lookup table---

	moveq		#$F,d0		;set lower for bits
	moveq		#$-16,d1		;set upper four bits
	moveq		#5,d2			;5 in lower 4 bits
	moveq		#$50,d3		;5 in upper 4 bits
	moveq		#0,d4			;d4 is the counter
LookupGenerateLoop:
	move.b	d4,d5			;copy of counter
	and.b		d0,d5			;isolate lower nyble of counter
	cmp.b		d2,d5			;is the nyble too large?
	bcs.s		LowerNybleFine
	addq.b	#3,d5
	and.b		d0,d5			;there could have been a carry into the upper 4 bits
LowerNybleFine:
	move.b	d4,d6			;copy of counter
	and.b		d1,d6			;isolate upper nyble of counter
	cmp.b		d3,d6			;is the nyble too large?
	bcs.s		UpperNybleFine
	add.b		#$30,d6		;adjust it, no need to worry about carry for this one
UpperNybleFine:
	or.b		d6,d5
	move.b	d5,0(a4,d4)		;store it to the array
	addq.b	#1,d4
	bcc.s		LookupGenerateLoop
;-------------------------------------------------------------
;Clear out the location of the BCD values
;-------------------------------------------------------------
	moveq		#99,d0
	move.l	a1,a5
ClearLoop:
	clr.l		-(a5)
	dbra		d0,ClearLoop
;--------------------------------------------------------------
;now for the bitshifting algorithm
;--------------------------------------------------------------
	moveq		#0,d5
	move.b	-(a3),d5
	lsl.w		#3,d5		;number of bits to shift out
	subq.b	#1,d5
	bcs.s		TheValueIsZero
	moveq		#2,d3		;aproximation of size as 1 byte, with 1 decimal digit

;------------------------------------------------
;This point in the loop gets the next byte.
;and it updates the aproximation of where in
;ram it should work with.
;------------------------------------------------
DoTheConversionAndGetNextByte:
	add.w		#5,d3
	move.w	d3,d2
	lsr.w		#4,d2		;the amount of rotatind to do with 8 roxls
	moveq		#7,d6		;what bit of the integer needs isolating
	move.b	-(a3),d4	;the first bye


;----now do the shifting----------------

DoTheConversion:
	move.w	d2,d0		
	move.l	a1,a5
	add.b		d4,d4
ShiftLoop:
	roxl.w	-(a5)
	roxl.w	-(a5)
	roxl.w	-(a5)
	roxl.w	-(a5)		;8 bytes rotated
	dbra		d0,ShiftLoop

;----Bytes need adjusting------------

	subq.w	#1,d5
	bcs		DoneConverting	
	move.l	a1,a5
	move.w	d3,d1
	lsr.w		#2,d1
	moveq		#0,d0
AdjustBytesLoop:
	move.b	-(a5),d0
	move.b	0(a4,d0),(a5)
	move.b	-(a5),d0
	move.b	0(a4,d0),(a5)
	dbra		d1,AdjustBytesLoop

;----See if another byte is needed------

	subq.b	#1,d6
	bcc.s		DoTheConversion
	bra		DoTheConversionAndGetNextByte
DoneConverting:
TheValueIsZero:
;----------------------------------------------
;Convert from BCD to a string
;d3 is the aproximation of its size
;----------------------------------------------
	clr.b		(a2)		;null terminate
	moveq		#'0',d1
	move.w	d3,d0
	lsr.w		#2,d0
	move.b	#$F,d2
ExpandBCD:
	move.b	-(a1),d3
	move.b	d2,d4
	and.b		d3,d4		;mask it out
	add.b		d1,d4		;convert to integer
	move.b	d4,-(a2)
	lsr.b		#4,d3
	add.b		d1,d3
	move.b	d3,-(a2)
	dbra		d0,ExpandBCD
GetPastLeadingZeros:
	cmp.b		(a2)+,d1
	beq.s		GetPastLeadingZeros
	tst.b		-(a2)		;null terminator?
	bne		NotNull
	move.b	d1,-(a2)
NotNull:
;-----------------------------------------
;When done a2 points to the string
;-----------------------------------------
	dbra		d7,DoItRepeatedly
	move.b	20(a2),d3
	clr.b		20(a2)
	move.w	#4,-(a7)
	move.l	a2,-(a7)
	clr.l		-(a7)
	move.l	1700(a6),a0
	jsr		(a0)			;print the string
	lea		10(a7),a7
	clr.w		d0
	trap		#1
	move.l	324(a6),a0
	jsr		(a0)			;idle
	cmp.w		#269,d0		;f2?
	bne		NotF2
	moveq		#19,d7
	bra		DoingItAgainMultiple
NotF2:
	cmp.w		#268,d0		;f1?
	bne		NotF1
	moveq		#9,d7
	bra		DoingItAgainMultiple
NotF1:
	cmp.w		#13,d0		;enter key?
	bne		PutItToEstack
	moveq		#0,d7
DoingItAgainMultiple:
	move.w	#$0200,d0
	trap		#1
	bra		DoItAllOver

;----put it to the estack----

PutItToEstack:
	move.b	d3,20(a2)
	move.l	1060(a6),a1
	move.l	(a1),a0		;get top estack
	addq.l	#1,a0
	clr.b		(a0)+
Cupir
	move.b	(a2)+,(a0)+
	bne		Cupir
	move.b	#$2D,(a0)
	move.l	a0,(a1)

;---The second exit to return a value-----

	lea		3000(a7),a7
	lea		LCD_MEM+3840,a0
	move.w	#959,d0
Restore2
	move.l	(a7)+,-(a0)
	dbra		d0,Restore2
	move.w	(a7)+,d0
	trap		#1
	movem.l	(a7)+,d3-d7/a2-a6

;---return value hack----

	move.l (a7)+,a0			;get return address
	moveq.l #4,d0
	cmpi.w #$21EE,(a0)
	bne.s Keep4
	moveq.l #6,d0
Keep4:
	add.l d0,a0
	jmp (a0)

;---exit now-------

NotAnInt:
	lea		3000(a7),a7
	lea		LCD_MEM+3840,a0
	move.w	#959,d0
Restore
	move.l	(a7)+,-(a0)
	dbra		d0,Restore

	move.w	(a7)+,d0
	trap		#1
	movem.l	(a7)+,d3-d7/a2-a6
	rts


msg:	dc.b		"Now converting",0